#!/usr/bin/python3
# -*- coding: UTF-8 -*-
#
#   commTee.py
#
#       command実行とfile出力を行う
#       linuxの場合はteeコマンドがあるが、windowsの場合は無い為作成。
#
#       commTee.py <command> <arg1> <arg2> ... <fileName>
#
#   19/01/29    新規作成
#

import sys
import subprocess


def printHelp():
    cont = """
----- <commTee.py> ---------------------------------------------------------
command実行とその出力をfileに出力する。
windowsでは、teeコマンドが無いため、その代用。

<使い方>
commTee.py <command> [<args1> <args2> ...] <fileName>
  command       :実行するコマンド
  args1 ...     :コマンドの引数（省略可）
  fileName      :コマンドが出力する内容を保存するfileName

<例>
commTee.py dir test.txt
"""
    print (cont)

def commTee(comms):
    comm = " ".join(comms)
    proc = subprocess.Popen(
            comm,
            shell=True,
            stdout=subprocess.PIPE,
            stderr=subprocess.PIPE)
    for line in iter(proc.stdout.readline, b""):
        line = line.decode("shift-jis")
        print (line, end="")
        if line[-2:] == "\r\n":
            line = line[:-2] + "\n"
        f.write(line)


if __name__ == "__main__":
    if len(sys.argv) <= 2:
        print (u"引数が不足しています")
        printHelp()
        exit()
    comms = sys.argv[1:-1]
    outFile = sys.argv[-1]
    f = open(outFile, "w", encoding="utf-8")
    if comms[0][0] == "-":
        printHelp()
        exit()
    try:
        commTee(comms)
    except KeyboardInterrupt:
        pass
    finally:
        f.close()

