#!/usr/bin/python3  
# -*- coding: utf-8 -*-
#
#       deleteOverlapNodesDDialog2.py
#
#           節点Group間や節点Groupと面Group間で重複している節点を削除する。
#
#   18/01/28    新規作成
#      02/02    Show関数追加
#      06/17    checkNodeNumOfNgrp:group内の全nodeが削除された場合、エラー発生するので修正
#      11/25    overlapNamesを受けてGUI表示、「OK」ボタンでメッシュ情報を再取得する様に修正
#   19/01/09    python3用に書き換え
#      01/13    glade3のdialog表示に対応
#      01/26    okDialog:type→message_typeに修正
#      03/09    okDeleteNodes:バグ修正（nodeGrpの順番が正しく取得されていなかった。）
#

import gi
gi.require_version("Gtk", "3.0")
from gi.repository import Gtk

import sys
import os
import glob
import pyFistr
import deleteOverlapNodeInNgrp as delnd

meshHeaderData = []
ngrpNames = []
ngrps = []
allNgrpNames = []
ls = "\n"

stat = ""



#
#  Show
#  ----
def Show(overlapNGRP):
    global ngrpNames, meshHeaderData, ngrps, allNgrpNames, otherNames, stat
    overlapNames = overlapNGRP
    #textBoxに表示するNGRP名を取得
    ngrpNames = overlapNames
    app = dialogApp()
    app.main()
    return [stat, meshHeaderData]

#  ---------
#  dialogApp
#  ---------
#    GUIの起動と終了
class dialogApp(Gtk.Dialog):

    #  dialogの初期化
    def __init__(self, *argv, **kwds):
        Gtk.Dialog.__init__(self, **kwds)
        self.builder = Gtk.Builder()
        #builder.add_from_file(os.getenv("easyIstrPath") + os.sep + "easyIstr_2.glade")
        self.builder.add_from_file(os.path.dirname(os.path.abspath(__file__)) + os.sep + "deleteOverlapNodesDDialog2.glade")
        self.dialog = self.builder.get_object("dialog1")
        self.dialog.connect("delete-event", self.close)
        self.builder.connect_signals(self)
        self.dialog.set_transient_for(self)
        #objectの定義
        self.setGtkObject()
        self.subInitialize()

    #  dialogの表示
    def main(self):
        #self.dialog.run()
        self.dialog.show()
        Gtk.main()

    #
    #  GUIの終了
    #
    def close(self, *args):
        self.dialog.hide()
        Gtk.main_quit()

    #
    #  handler
    #  --------------------------------
    #OK
    def onOk(self, event):
        self.okDeleteNodes()
        self.dialog.hide()        
        Gtk.main_quit()
    #キャンセル
    def onCancel(self, event):
        global stat
        stat = "cancel"
        self.dialog.hide()
        Gtk.main_quit()
    #上に移動
    def onMoveUp(self, event):
        self.ngrpMoveUp()
    #下に移動
    def onMoveDown(self, event):
        self.ngrpMoveDown()
    #重複箇所...chekBox
    def onChangeDelMode(self, event):
        self.changeDelMode()
    #----------------------------------------

    #
    #  setGtkObject
    #    objectの定義
    def setGtkObject(self):
        self.checkBtn_toSur = self.builder.get_object("checkbutton1")
        self.checkBtn_toNode = self.builder.get_object("checkbutton2")
        self.button_moveUp = self.builder.get_object("button1")
        self.button_moveDown = self.builder.get_object("button2")
        self.button_OK = self.builder.get_object("button3")
        self.button_cancel = self.builder.get_object("button4")
        self.listBox_ngrp = self.builder.get_object("treeview2")
        self.listBox_ngrp.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        self.label_delExp = self.builder.get_object("label3")
        self.label_boxTitle = self.builder.get_object("label6")
        self.label_boxUp = self.builder.get_object("label4")
        self.label_boxDwn = self.builder.get_object("label5")
        self.listmodel_ngrp = Gtk.ListStore(str)

    #
    #  subInitialize
    #
    def subInitialize(self):
        #listBoxにitemをセット
        self.setListDataInListBox(self.listmodel_ngrp, self.listBox_ngrp, ngrpNames)
        path = (0)
        self.listBox_ngrp.get_selection().select_path(path)
        #checkBoxを設定
        self.checkBtn_toNode.set_active(True)
        self.checkBtn_toSur.set_active(True)
        self.changeDelMode()
        #titleをセット
        self.dialog.set_title(_("重複節点の削除"))

    #
    #  setListDataInListBox
    #    listBoxをクリアしてデータをセットする
    def setListDataInListBox(self, listModel, listBox, setNames):
        listModel.clear()
        if len(setNames) == 0:
            listModel.append(["(None)"])
        else:
            for name in setNames:
                listModel.append([name])
        listBox.set_model(model=listModel)
        cols = [""]
        for i in range(len(cols)):
            coll = listBox.get_column(i)
            if coll != None:
                listBox.remove_column(coll)
            cell = Gtk.CellRendererText()
            col = Gtk.TreeViewColumn(cols[i], cell, text=i)
            listBox.append_column(col)
        listBox.set_headers_visible(False)

    #
    #  changeDelMode
    #    節点削除modeを変更する
    def changeDelMode(self):
        if self.checkBtn_toNode.get_active() == True:
            #labelを隠す
            self.label_delExp.set_sensitive(False)
            self.label_boxTitle.set_sensitive(False)
            self.label_boxUp.set_sensitive(False)
            self.label_boxDwn.set_sensitive(False)
            self.listBox_ngrp.set_sensitive(False)
            self.button_moveUp.set_sensitive(False)
            self.button_moveDown.set_sensitive(False)
        else:
            #labelを表示
            self.label_delExp.set_sensitive(True)
            self.label_boxTitle.set_sensitive(True)
            self.label_boxUp.set_sensitive(True)
            self.label_boxDwn.set_sensitive(True)
            self.listBox_ngrp.set_sensitive(True)
            self.button_moveUp.set_sensitive(True)
            self.button_moveDown.set_sensitive(True)

    #
    #  ngrpMoveUp
    #    選択したnamesを一段上昇する
    def ngrpMoveUp(self):
        global ngrpNames
        (listmodel, pathList) = self.listBox_ngrp.get_selection().get_selected_rows()
        if len(pathList) == 0:
            title = _(u"NGRPの選択")
            mess = _(u"NGRP名を選択してください")
            self.errDialog(title, mess)
            return
        #全namesを取得
        allNames = self.getNamesInListmodel(self.listmodel_ngrp)
        #選択しているnamesを取得
        selNames = []
        for path in pathList:
            selName = allNames[path[0]]
            selNames.append(selName)
        #順番を1ヶ上昇
        if selNames[0] != allNames[0]:
            for selName in selNames:
                seli = 0
                for i in range(len(allNames)):
                    if selName == allNames[i]:
                        seli = i
                        break
                if seli > 0:
                    allNames = allNames[:seli-1] + [selName] + [allNames[seli-1]] + allNames[seli+1:]
        #listBoxに表示
        self.setListDataInListBox(self.listmodel_ngrp, self.listBox_ngrp, allNames)
        #選択Namesｗっを選択表示させる
        self.showSelectItemsInListBox(self.listBox_ngrp, allNames, selNames)
        #global変数にlistをセット
        ngrpNames = allNames

    #
    #  ngrpMoveDown
    #    選択したnamesを一段下げる
    def ngrpMoveDown(self):
        global ngrpNames
        (listmodel, pathList) = self.listBox_ngrp.get_selection().get_selected_rows()
        if len(pathList) == 0:
            title = _(u"NGRPの選択")
            mess = _(u"NGRP名を選択してください")
            self.errDialog(title, mess)
            return
        #全namesを取得
        allNames = self.getNamesInListmodel(self.listmodel_ngrp)
        #選択しているnamesを取得
        selNames = []
        for path in pathList:
            selName = allNames[path[0]]
            selNames.append(selName)
        #順番を1ヶ下げる
        if selNames[-1] != allNames[-1]:
            n = len(selNames) - 1
            while n >= 0:
                selName = selNames[n]
                seli = len(allNames) - 1
                i = len(allNames) - 1
                while i >= 0:
                    if selName == allNames[i]:
                        seli = i
                        break
                    i -= 1
                if seli < len(allNames)-1:
                    allNames = allNames[:seli] + [allNames[seli+1]] + [selName] + allNames[seli+2:]
                n -= 1

        #listBoxに表示
        self.setListDataInListBox(self.listmodel_ngrp, self.listBox_ngrp, allNames)
        #選択Namesｗっを選択表示させる
        self.showSelectItemsInListBox(self.listBox_ngrp, allNames, selNames)
        #global変数にlistをセット
        ngrpNames = allNames

    #  getNamesInListmodel
    def getNamesInListmodel(self, listmodel):
        names = []
        iter = listmodel.get_iter_first()
        while iter != None:
            name = listmodel.get_value(iter, 0)
            names.append(name)
            iter = listmodel.iter_next(iter)
        return names

    #
    #  showSelectItemsInListBox
    #    listBox内のselNamesを選択表示する
    def showSelectItemsInListBox(self, listBox, allNames, selNames):
        n = 0
        for name in allNames:
            for selName in selNames:
                if name == selName:
                    path = (n)
                    listBox.get_selection().select_path(path)
            n += 1

    #
    #  okDeleteNodes
    #
    def okDeleteNodes(self):
        global stat
        global ngrpNames, meshHeaderData, ngrps, allNgrpNames, otherNames
        stat = "OK"
        #必要なメッシュ情報を取得
        lines = pyFistr.readFistrModelMsh()
        meshHeaderData = pyFistr.getHeaderNumData(lines)
        [ngrps, allNgrpNames] = delnd.getNgrpData(meshHeaderData)
        [overlapNames, otherNames] = delnd.getOverlapNgrpNames(ngrps, allNgrpNames)
        overlapNames.sort()
        ngrpNames.sort()
        #当初のoverlapNamesと現在のoverlapNamesが合致しているかどうかチェック
        if overlapNames != ngrpNames:
            #合致していない場合
            title = _(u"エラー")
            mess = _(u"エラーが発生しました。") + "\n" + _(u"節点は削除していません。")
            self.errDialog(title, mess)
            stat = "cancel"
        else:
            #合致している場合
            #  node削除する順番でngrpNamesを取得
            ngrpNames = self.getNamesInListmodel(self.listmodel_ngrp)
            #  node削除
            self.deleteOverlapNodes()

    #
    #  deleteOverlapNodes
    #    重複節点を削除する
    def deleteOverlapNodes(self):
        global meshHeaderData
        orderNames = ngrpNames + otherNames
        if self.checkBtn_toNode.get_active() == True:
            nodeDataList = delnd.createNodeDataListDeleteEdge(ngrps, orderNames)
        else:
            nodeDataList = delnd.createNodeDataListFromNgrps(ngrps, orderNames)
        if len(ngrpNames) > 0:
            print (_(u"nodeGroup間の重複節点を削除しました。"))
        if self.checkBtn_toSur.get_active() == True:
            surNodes = delnd.getSurfaceNodes(meshHeaderData)
            nodeDataList = delnd.addNodeDataListFromSgrps(surNodes, nodeDataList)
            print (_(u"surfaceGroupとの重複節点を削除しました。"))
        #meshHeaderDataを再作成
        meshHeaderData = delnd.createMeshHeaderData(meshHeaderData, nodeDataList,
                                                    orderNames)
        #書き込み
        lines = pyFistr.createLinesFistrModelMshHeader(meshHeaderData)
        writeFileLines("FistrModel.msh", lines)
        #削除したgrpNamesを確認、表示
        delMess = checkNodeNumOfNgrp(ngrps, meshHeaderData)
        title = _(u"重複節点の削除")
        self.okDialog(title, delMess)

    def okDialog(self, title, message):
        dlg = Gtk.MessageDialog(
                parent=self.dialog,
                message_type=Gtk.MessageType.INFO,
                buttons=Gtk.ButtonsType.OK)
        dlg.set_title(title)
        #messageを分ける
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        dlg.run() 
        dlg.destroy()

    def errDialog(self, title, message):
        dlg = Gtk.MessageDialog(
                parent=self.dialog,
                message_type=Gtk.MessageType.ERROR,
                buttons=Gtk.ButtonsType.OK)
        dlg.set_title(title)
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        dlg.run() 
        dlg.destroy()


#
#  checkNodeNumOfNgrp
#    削除したnode数を確認
def checkNodeNumOfNgrp(ngrps, meshHeaderData):
    newNgrps = []
    for meshHeader in meshHeaderData:
        header = meshHeader[0]
        words = pyFistr.deleteSp(header).split(",")
        if words[0] == "!NGROUP":
            newNgrps.append(meshHeader)
    ngrpNums = []
    for ngrp in ngrps:
        name = pyFistr.getValName(ngrp[0], "NGRP")
        ngrpNums.append([name, len(ngrp[1])])
    ngrpNums.sort()
    newNgrpNums = []
    for newNgrp in newNgrps:
        name = pyFistr.getValName(newNgrp[0], "NGRP")
        newNgrpNums.append([name, len(newNgrp[1])])
    newNgrpNums.sort()
    mess = _(u"nodeGroup内の重複節点を削除しました。" + ls)
    #削除前後のnodeGroup数をチェック
    addMess = u""
    if len(ngrpNums) == len(newNgrpNums):
        #各nodeGroupの節点の一部が削除された場合
        for i in range(len(ngrpNums)):
            name = ngrpNums[i][0]
            num = ngrpNums[i][1]
            newNum = newNgrpNums[i][1]
            delNum = num - newNum
            if delNum > 0:
                addMess += "  " + name + ":  " + str(delNum) + " /" + str(num) + _(u" 削除") + ls
    else:
        #ngrpの数が合わない場合（ngrp内の全ての節点が削除された場合）
        for ngrpNum in ngrpNums:
            flag = 0
            for newNgrpNum in newNgrpNums:
                if ngrpNum[0] == newNgrpNum[0]:
                    flag = 1
                    break
            if flag == 1:
                #節点の一部が削除された場合
                name = ngrpNum[0]
                num = ngrpNum[1]
                newNum = newNgrpNum[1]
                delNum = num - newNum
                if delNum > 0:
                    addMess += "  " + name + ":  " + str(delNum) + " /" + str(num) + _(u" 削除") + ls
            else:
                #節点全て削除されngrpが削除されている場合
                name = ngrpNum[0]
                addMess += "  " + name + ":  " + str(num) +" /" + str(num) + _(u" 全て削除!!") + ls
    if addMess == "":
        mess = _(u"削除する重複節点は、ありません。")
    else:
        mess += addMess
    return mess

#
#  initialize
#
def initialize():
    global ngrpNames, meshHeaderData, ngrps, allNgrpNames, otherNames
    #ngrpNames = ["fix", "load", "press", "xxx", "yyyy", "zzzz"]
    #メッシュファイル読み込み
    lines = delnd.readFistrModelMsh()
    #meshHeaderDataを取得
    meshHeaderData = pyFistr.getHeaderNumData(lines)
    #ngrp部を取得
    [ngrps, allNgrpNames] = delnd.getNgrpData(meshHeaderData)
    #overlapしているNGRP名を取得
    [overlapNames, otherNames] = delnd.getOverlapNgrpNames(ngrps, allNgrpNames)
    overlapNames.sort()
    #textBoxに表示するNGRP名を取得
    ngrpNames = overlapNames

#
#  writeFileLines
#    fileに書き込み
def writeFileLines(fileName, lines):
    f = open(fileName, "w")
    for line in lines:
        f.write(line)
    f.close()

    
if __name__ == "__main__":
    import gettext
    gettext.install("app")
    _ = gettext.gettext

    initialize()
    app = dialogApp()
    Gtk.main()

