#!/usr/bin/python3
# -*- coding: utf-8 -*-    
#
#       settingDialog2.py
#
#           設定中dialog表示
#
#   17/08/29    新規作成
#      09/28    windowの表示位置をマウス位置に変更
#   19/01/26    python3、glade3用に書き換え
#      04/22    timerEvent:dialogを閉じる条件を修正（>100.0 → >100.1）
#               timerEvent時間を 10 → 50ms に修正。
#
#

import gi
gi.require_version("Gtk", "3.0")
from gi.repository import Gtk
from gi.repository import GLib

import sys   
import os   
import time

ls = "\n"
title = ""
setCont = ""
setting = ""


#-------------------
#  windowApp
#-------------------
#    GUIの起動と終了
class windowApp:  

    #  GUIの初期化
    def __init__(self):

        #Set the Glade file
        gladefile = "settingDialog2.glade"  
        self.builder = Gtk.Builder()  
        self.builder.add_from_file(os.path.dirname(os.path.abspath(__file__)) +
                os.sep + gladefile)  

        self.setGtkObject()
        self.subInitialize()

        #windowを表示
        self.builder.connect_signals(self)
        self.mainWindow = self.builder.get_object ("window1")
        self.mainWindow.connect("delete-event", self.close)
        #title = _(u"設定中...")
        self.mainWindow.set_title(title)
        #timerEventを作成（0.2s）
        GLib.timeout_add(200, self.timerEvent)

    #  GUIの表示
    def main(self):
        self.mainWindow.show_all()
        Gtk.main()

    #  GUIの終了
    def close(self, *args):
        Gtk.main_quit(*args)

    #
    #  setGtkObject
    #    objectの定義
    def setGtkObject(self):
        self.label_setCont = self.builder.get_object("label1")
        self.label_setting = self.builder.get_object("label2")
        self.prgBar = self.builder.get_object("progressBar1")

    #
    #  subInitialize
    #    初期化
    def subInitialize(self):
        self.label_setCont.set_text(setCont)
        self.label_setting.set_text(setting)

    #
    #  timeerEvent
    #    timerEventの処理
    def timerEvent(self):
        #line = raw_input()
        line = input()
        if line[:len("close")] == "close":
            #windowを閉じて終了
            Gtk.main_quit()
        else:
            words = line.split(",")
            word = words[0]
            if len(words) >= 2:
                setCont = words[1]
                self.label_setCont.set_text(setCont)
            try:
                a = float(word)
                setLine = setting + str(a) + " %"
                self.label_setting.set_text(setLine)
                self.prgBar.set_fraction(a/100.0)
                if a > 100.1:
                    #windowを閉じて終了
                    Gtk.main_quit()
            except:
                pass
        #timerEventを設定して戻る(50ms)
        GLib.timeout_add(50, self.timerEvent)


if __name__ == "__main__":  
    import gettext
    gettext.install("app") # replace with the appropriate catalog name
    _ = gettext.gettext

    setCont = ""
    title = _(u"設定中... ")
    setting = _(u"設定中... ")
    if len((sys.argv)) == 2:
        title = sys.argv[1]
        setCont = sys.argv[1]
    app = windowApp()  
    app.main()

